searchNodes=[{"ref":"TelemetryAsync.Handler.html","title":"TelemetryAsync.Handler","type":"module","doc":"GenServer that subscribes to the requested telemetry metrics. The handler will randomly distribute requests to the ShardSupervisor Shards and re-execute the telemetry metrics with :async prepended to the beginning. A metric like [:test] will become [:async, :test] The metrics are detached if the Handler process exits to allow graceful shutdown."},{"ref":"TelemetryAsync.Handler.html#child_spec/1","title":"TelemetryAsync.Handler.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"TelemetryAsync.Handler.html#start_link/1","title":"TelemetryAsync.Handler.start_link/1","type":"function","doc":"Starts the Telemetry.Handler. Several options are available: metrics -(required) Must be provided. This is a list of telemetry metric names. They must be lists of atoms, like telemetry accepts pool_size - (optional) The size of the ShardSupervisor pool. This defaults to the number of schedulers prefix - (optional) An atom that is used to name the individual Shards. Defaults to TelemetryAsync.Shard The prefix and pool_size should match a ShardSupervisor started with the same options or the telemetry events will not be re-broadcast."},{"ref":"TelemetryAsync.ShardSupervisor.html","title":"TelemetryAsync.ShardSupervisor","type":"module","doc":"Supervisor that manages the Shards. The requested number of shards will be started with the specified prefix"},{"ref":"TelemetryAsync.ShardSupervisor.html#child_spec/1","title":"TelemetryAsync.ShardSupervisor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"TelemetryAsync.ShardSupervisor.html#init/1","title":"TelemetryAsync.ShardSupervisor.init/1","type":"function","doc":"Callback invoked to start the supervisor and during hot code upgrades. Developers typically invoke Supervisor.init/2 at the end of their init callback to return the proper supervision flags. Callback implementation for Supervisor.init/1."},{"ref":"TelemetryAsync.ShardSupervisor.html#start_link/1","title":"TelemetryAsync.ShardSupervisor.start_link/1","type":"function","doc":"Starts the ShardSupervisor. There are several options available: prefix - (optional) An atom that is used to name the individual Shards. Defaults to TelemetryAsync.Shard pool_size - (optional) The size of the ShardSupervisor pool. This defaults to the number of schedulers"},{"ref":"readme.html","title":"TelemetryAsync","type":"extras","doc":"TelemetryAsync This library provides async execution of telemetry events so that the caller site is not blocked while your metrics are processed. This can be desirable if you have metrics that are in your user impacting flow which could slow down your requests. Slow telemetry handlers, such as writing to a database, can make this effect worse. TelemetryAsync works by adding a handler to the metrics that you ask it to. It handles these events (ie. [:a, :b]) and processes them in a sharded supervised process set. The process will execute the event under the name with :async prepended (ie. [:async, :a, :b]). You can customize the pool size or have multiple async pools running at once. The default pool size is the number of schedulers which will help maximize the speed of processing the metrics."},{"ref":"readme.html#installation","title":"TelemetryAsync - Installation","type":"extras","doc":"This package can be installed by adding telemetry_async to your list of dependencies in mix.exs: def deps do [ {:telemetry_async, &quot;~&gt; 0.0.1&quot;} ] end"},{"ref":"readme.html#configuration","title":"TelemetryAsync - Configuration","type":"extras","doc":"You must add a TelemetryAsync.ShardSupervisor and TelemetryAsync.Handler to your application (either in Application or another Supervisor). This is to allow you to control the startup and shutdown of the processes. It is advised to start the ShardSupervisor before the Handler so that the pool is ready when events process. You can add it to your application like: use Application def start(_type, _args) do children = [ TelemetryAsync.ShardSupervisor, { TelemetryAsync.Handler, metrics: [ [:metric_one], [:prefix, :metric_two] ] } ] opts = [strategy: :one_for_one, name: MyApp.Supervisor] Supervisor.start_link(children, opts) end You can customize the ShardSupervisor and Handler by specifying the size of the execution pool and the prefix of the Shards. This is useful if you want to have multiple Supervisors in your application. This is documented in the hexdocs. The Handler will unsubscribe from all subscribed metrics when it terminates."}]